/* E-run is a simple epplet to launch programs.
 * The original program called E-Run
 * was written by Jacob Kuenzel - jacob@mattk.nccw.net
 * http://mattk.nccw.net/~jacob/c0de/E-Run.c
 * I found the idea great but I did not like the
 * program so I rewrote it to fit my tastes.
 * 
 * Alexandre David
 * adavid@docs.uu.se
 * http://www.docs.uu.se/~adavid
 *
 * There is a segmentation fault bug that does
 * not seem to come from this code. It appears
 * if you play very much with the command line.
 * I think it is a problem in the label.
 *
 * When changing theme, this epplet will not
 * work any more, I think it is due to the fact
 * that I do not have any timer. This should be
 * fixed by enlightenment eventually I hope.
 *
 * As for the original program, weird characters may not
 * be used, i.e. !@#$%^&*
 *
 * License: GPL
 * Version: 1.0
 * Changes: 0.1 creation
 *          0.2 added setpriority
 *          0.3 updated makefile for Epplets-0.5 compliance
 *          0.4 makefile fix
 *          1.0 makefile cleanup
 */

/* choose epplet(1) or code generator(0) */
#if 1

#include<epplet.h>
#include<signal.h>
#include<sys/time.h>
#include<sys/resource.h>

#define RETURN 0x5e911a08
#define SPACE 0xd315a60
#define PERIOD 0xda8e729f
#define MINUS 0xc80a3dc
#define SLASH 0xd2e453f
#define GRAVE 0xbdbbd8d
#define SHIFT_L 0x4f06d2f5
#define SHIFT_R 0x4f06d2fb
#define CAPS_LOCK 0x433897cb
#define BACKSPACE 0x8cc0a0f1

#define VERSION "1.0"
#define WIDTH 6
#define LEN 512

Epplet_gadget close_button,com_label,title_label;
int shifted=0,size=0,w=0;
char command[LEN];
char *com; /* to remember the last cut to save the last computation */

void focus_in() {
  if (!size) {
    Epplet_gadget_hide(title_label);
    Epplet_gadget_show(com_label);
  }
  Epplet_gadget_show(close_button);
}

void focus_out() {
  if (!size) {
    Epplet_gadget_show(title_label);
    Epplet_gadget_hide(com_label);
  }
  Epplet_gadget_hide(close_button);
}

void quit() {
  exit(0);
}

void key_pressed(void *data, Window win, char *key) {
  int n=strlen(key),w,h;
  char c;
  /* printf("[%d:%s]%s\n",size,com,key); */
  
  if (n>1) {
    int code=0;
    for(;n>0;n--) code=code*37+*key++;
    switch(code) {
      
    case RETURN:
      if (!size) return;
      size=0;
      com=&command[0];
      Epplet_spawn_command(command);
      goto update;
      
    case SPACE:      c=' '; break;
    case PERIOD:     c='.'; break;
    case MINUS:      c=(shifted ? '_' : '-'); break;
    case SLASH:      c='/'; break;
    case GRAVE:      c='~'; break;
      
    case SHIFT_L:
    case SHIFT_R:
    case CAPS_LOCK:
      shifted=(!shifted);
      return;
      
    case BACKSPACE:
      if (!size) return;
      size--;
      if (com>&command[0]) com--;
      goto update;
      
    default:
      /* unknown -> ignore */
      return;
    } /* switch(code) */
  } /* if (n>1) */
  else c=*key;

  if (size<LEN-1)
    command[size++]=(shifted ? toupper(c) : c);
  else
    return;

 update:
  command[size]='\0';
  Epplet_textclass_get_size("EPPLET_LABEL",&w,&h,com);
  while(w>(WIDTH-1)*16-10 && com<&command[LEN-1])
    Epplet_textclass_get_size("EPPLET_LABEL",&w,&h,++com);
  Epplet_change_label(com_label,com);
}

void key_released(void *data, Window win, char *key) {
  if (!strncmp("Shift",key,5))
    shifted=(!shifted);
}

int main(int argc,char* argv[]) {
  setpriority(PRIO_PROCESS,getpid(),getpriority(PRIO_PROCESS,getpid())+10);
  com=&command[0];
  command[0]='\0';
  Epplet_Init("E-run",VERSION,"Enlightenment Run Command Epplet",WIDTH,1,argc,argv,0);

  atexit(Epplet_cleanup);
  signal(SIGTERM,exit);
  signal(SIGINT,exit);

  close_button=Epplet_create_button(NULL,NULL,(WIDTH-1)*16+2,2,0,0,"CLOSE",0,NULL,quit,NULL);
  com_label=Epplet_create_label(10,4,"",1);
  Epplet_gadget_show(Epplet_create_label(3,4,">",1));
  Epplet_gadget_show(title_label=Epplet_create_label(10,4,"RUN COMMAND",1));

  Epplet_register_focus_in_handler(focus_in,NULL);
  Epplet_register_focus_out_handler(focus_out,NULL);
  Epplet_register_key_press_handler(key_pressed,NULL);
  Epplet_register_key_release_handler(key_released,NULL);

  Epplet_show();
  Epplet_Loop();
  return 0;
}

#else

/******************************************
 * Temporary program to generate the codes
 */

#include<stdio.h>
#include<stdlib.h>
#include<ctype.h>

#define N 10
static char *words[N]={
  "Return","space","period","minus",
  "slash","grave",
  "Shift_L","Shift_R",
  "Caps_Lock","BackSpace"
};

int code(char *data) {
  int n=strlen(data);
  int code=0;
  for(;n>0;n--) code=code*37+*data++;
  return code;
}

char* toUpper(char* str,int n) {
  char *s=(char*)malloc(sizeof(char)*n);
  int i=0;
  for(;i<n;i++) s[i]=toupper(str[i]);
  s[i]='\0';
  return s;
}
  
int main(int argc,char *argv[]) {
  int i;
  for(i=0;i<N;i++) {
    char *s=toUpper(words[i],strlen(words[i]));
    printf("#define %s 0x%x\n",s,code(words[i]));
    free(s);
  }
  return 0;
}

#endif






